#include "StarPacket.h"
#include <signal.h>
#include <unistd.h>
#include <time.h>
#ifndef IFNAMSIZ
#define IFNAMSIZ 256
#endif

#define verb(x) if (verbose) std::cout<<x<<std::endl;

class AuthEngine: public StarPacket{
  public:
    AuthEngine(char *dev);
    int Auth();
    int Echo();
    int Loop();
    void Stop(int sig);
    int stage;
  private:
    unsigned char packet[1000];
};

AuthEngine::AuthEngine(char *dev)
  :StarPacket(dev)
{
  memset(packet,0,1000);
}

int
AuthEngine::Loop()
{
  while(1){
#if defined(__WIN32)
    _sleep(20000);
#else
    sleep(20);
#endif
    BuildEcho();
    Write(45);
  }
}
int flag = 0;
int
AuthEngine::Auth()
{
  int length;
  int ret;
  if (flag==0){
    ip = 0;
    mask = 0;
  }else{
    GetIPs();
    flag = 1;
  }

  /* Ѱҷ */
  type = ST_START;
  Build();
  verb("finding server...");
  Write(1000);
  /* û */
  verb("now waiting for response....");
  do{length=Read();}while(length==0);
  ret=Parse();
  if (ret==-1) return -1;
  if (flag==SF_FAILURE) {
    Err(message);
    return 0;
  }
  verb("sending user name");
  Build();
  Write(1000);
  /*  */
  length = Read();
  ret=Parse();
  if (ret==-1) return -1;
  if (flag==SF_FAILURE) {
    Err(message);
    return 0;
  }
  verb("username accepted. now sending password");
  Build();
  Write(1000);
  /* Ļ֤ɹϢ */
  length = Read();
  ret=Parse();
  if (ret==-1) return -1;
  if (flag==SF_FAILURE) {
    Err(message);
    return 0;
  }
  if (flag==SF_SUCCESS) {
    Msg(message);
    verb("success!!");
    return 1;
  }
  return 0;
}

int
AuthEngine::Echo()
{
  BuildEcho();
  Write(45);  /* length of echo is always 45 */
  return 0;
}

int main(int argc, char *argv[])
{
  int ret;
  int pid;
  int ch;
  char ifname[IFNAMSIZ];
  char user[32];
  char passwd[32];
  int index;
  int dev_flg = 0;
  char buf[256];

  opterr = 0;memset(user,0,32);memset(passwd,0,32);memset(ifname,0,IFNAMSIZ);

  while((ch = getopt(argc, argv, "i:p:u:"))!=-1){
    switch(ch){
      case 'i':
        strncpy(ifname, optarg, IFNAMSIZ);
	break;
      case 'p':
	strncpy(passwd, optarg, 32);
	break;
      case 'u':
	strncpy(user, optarg, 32);
	break;
      default:
	printf("usage: %s -i dev [-u user] [-p password]\n", argv[0]);
	return -1;
    }
  }
  if (strlen(ifname)==0){
    printf("usage: %s -i dev [-u user] [-p password]\n", argv[0]);
    return -1;
  }
  AuthEngine a(ifname);
  if (strlen(user)==0){
    printf("username:");
    scanf("%s",a.user);
  } else
    strncpy(a.user, user, 32);
  if (strlen(passwd)==0){
    //strncpy(a.passwd, getpass("Password: "),32);
    printf("password:");
    scanf("%s",a.passwd);
  } else
    strncpy(a.passwd, passwd, 32);
  ret = a.Auth();  /* auth for the first time to enable dhcp service */
  if (ret <=0) return 0;
#if defined(__WIN32)
  system("ipconfig /renew");
  _sleep(5000);
#else
//  char buf[256];    /**/
  snprintf(buf, 255, "ifdown %s",ifname); 
  system(buf);
  snprintf(buf, 255, "ifup %s", ifname);
  system(buf);
  sleep(5);
#endif
  ret = a.Auth();
  a.Loop();
}
