#ifndef _PACKET_CLASS_H_
#define _PACKET_CLASS_H_
#include <iostream>
#include <cstdio>
#include <errno.h>
#include <unistd.h>
#if defined(__WIN32)
#include <pcap.h>
#include <Packet32.h>
#include <Ntddndis.h>
#include <winsock2.h>
#else
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <netinet/in.h>
#include <net/if.h>
#include <linux/if_ether.h>
#include <netpacket/packet.h>
#include <net/ethernet.h>
#endif

class RawPacket
{
public:
  RawPacket(unsigned int protocol = 0, int buf_size = 65536);
  ~RawPacket();
  int Open(const char *ifname);
  int Close();
  int Read();
  int Write(int size);
  unsigned char * GetMacAddr();
  unsigned int GetIPs();
  void dump(int size, unsigned char *p = NULL);
  int Err(char *msg, int errcode = 0);
  void Msg(char *msg);
protected:
#if defined(__WIN32)
  unsigned int protocol;
  unsigned char *input;
  int input_size;
  unsigned char *output;
  int output_size;
  pcap_t *iface;
  char ifname[256];
  char errbuf[PCAP_ERRBUF_SIZE];
  pcap_if_t *all_devs;
  struct bpf_program fcode;
  unsigned int ip;
  unsigned int mask;
  unsigned int board;
#else
  int sock;
  unsigned int protocol;
  unsigned char *input;
  int input_size;
  unsigned char *output;
  int output_size;
  int buf_size;
  struct sockaddr_ll dev;
  struct ifreq req;
  int ifindex;
  char ifname[IFNAMSIZ];
  char ifaddr[IFHWADDRLEN];
  unsigned int ip;
  unsigned int mask;
  unsigned int board;
#endif
};

#endif
