#include "StarPacket.h"
	
StarPacket::StarPacket(char *dev)
	:RawPacket(ETH_P_8021X)
{
  if (Open(dev)==-1){
    Err("device not avaliable. abort");
    exit(0);
  }
  memcpy(mac, GetMacAddr(), 6);
  memset(dest, 0xFF, 6);
  type = ST_START;
  ip = 0;
  mask = 0;
  gate = 0;
  dns = 0;
  verbose = 1;
}

int 
StarPacket::Parse()
{
  unsigned char *p;
  unsigned short size;
  unsigned int i;
  unsigned short info_len;
  p = input;
  if ((input[0x0E]!=1)||(input[0x0F]!=0))
    return -1; //
  type = input[0x0F];
  size = ntohs(*(unsigned short *)(input+0x10)); /*Ϣ*/
  flag = input[0x12];
  id = input[0x13];
  memcpy(dest, input+6, 6);
  if (flag==SF_REQUEST) {
    info = input[0x16];
    if (info == SI_IDENTITY){
      return 0;
    }else if (info == SI_PASSWORD){
      key_len = input[0x17];
      i = key_len;
      memcpy(key, input+0x18, key_len);
      return 0;
    }else
      return -1;
  }else
  if (flag == SF_SUCCESS){
    p = input + 0x16;
    if ((ntohl(*(unsigned int *)p)!=0x1311))
      return -1;
    p+=4;
    /* welcome string length */
    info_len = ntohs(*(unsigned short *)p);
    p+=2;
    memset(message, 0, 256);
    memcpy(message, p, info_len);
    p += info_len;
    if ((ntohl(*(unsigned int *)p)!=0x1311))
      return -1;
    p += 4;
    /* һ */
    info_len = ntohs(*(unsigned short *)p);
    p += 2;
    /* ô */
    p += info_len;
    //p += 0x20;
    p += 12;
    /* Թλ 00 00 13 11 01 01 00 12 11 01 00 */
    dump(0x0F, p);
    Crypt(p, 0x0F);
    dump(0x0F, p);
    p += 4;  /* 00 00 13 11 */
    //magic = ntohs(*(unsigned short *)p);
    magic = 0x102A;
    p += 2;
    p += 2;  /* 00 00 */
    echo_key = ntohs(*(unsigned short *)p);
    p += 2;
    return 0;
  }else
  if (flag == SF_FAILURE){
    size = ntohs(*(unsigned short *)(input+0x1A));
    if (size==0) return 0;
    memset(message, 0, 256);
    memcpy(message, input+0x1C, size);
    return 0;
  }else
    return -1;
}

unsigned char *
StarPacket::BuildEcho()
{
  unsigned char * packet = output;
  unsigned char * p = packet;
  memset(packet, 0, 45);
  memcpy(p, dest, 6);
  p += 6;
  memcpy(p, mac, 6);
  p += 6;
  *(unsigned short *)p = htons(ETH_P_8021X);
  p += 2;
  *(p++) = 1;
  *(p++) = ST_ECHO;
  
  *(unsigned short *)p = htons(0x1E);  /* СôĳȲһ */
  p += 2;
  
  *(unsigned int *)p = htonl(0x1311);
  p += 4;
  *(p++) = 1;
  *(p++) = 6;
  *(p++) = 0;
  *(p++) = 0;
  magic++;
  *(unsigned short *)p = htons(echo_key+magic);
  p += 2;
  *(unsigned int *)p = htonl(0x1311);
  p += 4;
  *(p++) = 1;
  *(p++) = 6;
  *(p++) = 0;
  *(p++) = 0;
  *(unsigned int *)p = htons(magic);
  p += 2;
  *(unsigned int *)p = htonl(0x1311);
  p += 4;
  *(p++) = 1;
  *(p++) = 3;
  *(p++) = 0;

  Crypt(packet+0x12, 0x1B);
  return packet;
}

unsigned char *
StarPacket::Build()
{
  uint8_t *packet = output;
  uint8_t *p = packet;
  uint8_t md5buf[256];
  uint8_t md5len;
  uint8_t *md5p;
  int info_len;
  static char star_mac[] = {0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF};
  memset(packet, 0, 1000); /* bufferһҪ1000 */

  /* MACַ */
//  if (type == 1)
//    memcpy(p, star_mac, 6);
//  else
    memcpy(p, dest, 6);
  p += 6;
  memcpy(p, mac, 6);
  p += 6;
  *(unsigned short *)p = htons(ETH_P_8021X);
  p += 2;
  *(p++) = 1;
  *(p++) = type;

  if (type == ST_START){
    *(uint16_t *)p = 0;
    p += 2;
  }else
  if ((type == ST_AUTH)&&(info == SI_IDENTITY)){
    info_len = strlen(user) + 5;
    *(uint16_t *)p = htons(info_len);
    p += 2;
  }else
  if ((type == ST_AUTH)&&(info == SI_PASSWORD)){
    info_len = strlen(user) + 0x10 + 6;
    *(uint16_t *)p = htons(info_len);
    p += 2;
  }else{
    Err("unexpected status");
    return NULL;
  }

  /* startϢ */
  if (type == ST_AUTH){
    if (info_len<=5) return NULL;  /* impossible */
    *(p++) = SF_RESPONSE;          /* response */
    *(p++) = id;                   /* session id */
    *(uint16_t *)p = htons(info_len);    /* Ϣ */
    p += 2;
    *(p++) = info;                 /* SI_IDENTITY or SI_PASSWORD */
    if (info == SI_PASSWORD){      /* md5ܲ */
      *(p++) = 0x10;               /* md5ȣ0x10 */
      md5p = md5buf;
      /* Ϣ */
      *(md5p++) = id;
      memcpy(md5p, passwd, strlen(passwd));
      md5p += strlen(passwd);
      memcpy(md5p, key, key_len);
      md5p += key_len;
      md5len = md5p - md5buf;
      md5p = ComputeHash(md5buf, md5len);

      /* md5 */
      memcpy(p, md5p, 0x10);
      p += 0x10;
    }
    /* û */
    memcpy(p, user, strlen(user));
    p += strlen(user);
  }

  /* IP, dns, mask, gateļϢ */
  FillParam(p);
  p += 0x17;

  *(uint32_t *)p = htonl(0x1311);
  p += 4;
  memcpy(p, "8021x.exe", strlen("8021x.exe"));
  p += 0x20;        /* ﳤȹ̶Ϊ0x20 */

  /* һ߰Ķǹ̶ */
  *(p++) = 0x02;
  *(p++) = 0x32;
  *(p++) = 0x00;
  *(p++) = 0x00;
  *(p++) = 0x01;
  *(uint32_t *)p = htonl(0x1311);
  p += 4;
  *(p++) = 0x00;
  *(p++) = 0x28;
  *(p++) = 0x1a;
  *(p++) = 0x28;
  *(uint32_t *)p = htonl(0x1311);
  p += 4;
  *(p++) = 0x17;
  *(p++) = 0x22;

  /* Ҳ㲻ʲô˼-_- */
  if (info == SI_PASSWORD) {
    /* ַ֪ôģͬͬʺŶͬ
     * ûвԹͬͬ */
    sprintf((char *)p, "a1194737a3352f7c537baa3238c19514");
  }
  else {
    /* ʵĳһ֪ʲô */
    srand(time(0));
    snprintf((char *)p, 0x20, "%X%X%X%X%X%X388498639f49ebaca773dfd78789088ac9534", 
		    rand(), rand(), rand(), rand(), rand(), rand());
  }
  p += 0x20;

  *(uint32_t *)p = htonl(0x1311);
  p += 4;
  *(p++) = 0x18;
  *(p++) = 0x06;
  *(p++) = 0x00;
  *(p++) = 0x00;
  *(p++) = 0x00;
  *(p++) = 0x01;             /* ǲDHCP? */

  return output;
}

static unsigned char Table[]={
  0x00,0x00,0x21,0x10,0x42,0x20,0x63,0x30,
  0x84,0x40,0xA5,0x50,0xC6,0x60,0xE7,0x70,
  0x08,0x81,0x29,0x91,0x4A,0xA1,0x6B,0xB1,
  0x8C,0xC1,0xAD,0xD1,0xCE,0xE1,0xEF,0xF1,
  0x31,0x12,0x10,0x02,0x73,0x32,0x52,0x22,
  0xB5,0x52,0x94,0x42,0xF7,0x72,0xD6,0x62,
  0x39,0x93,0x18,0x83,0x7B,0xB3,0x5A,0xA3,
  0xBD,0xD3,0x9C,0xC3,0xFF,0xF3,0xDE,0xE3,
  0x62,0x24,0x43,0x34,0x20,0x04,0x01,0x14,
  0xE6,0x64,0xC7,0x74,0xA4,0x44,0x85,0x54,
  0x6A,0xA5,0x4B,0xB5,0x28,0x85,0x09,0x95,
  0xEE,0xE5,0xCF,0xF5,0xAC,0xC5,0x8D,0xD5,
  0x53,0x36,0x72,0x26,0x11,0x16,0x30,0x06,
  0xD7,0x76,0xF6,0x66,0x95,0x56,0xB4,0x46,
  0x5B,0xB7,0x7A,0xA7,0x19,0x97,0x38,0x87,
  0xDF,0xF7,0xFE,0xE7,0x9D,0xD7,0xBC,0xC7,
  0xC4,0x48,0xE5,0x58,0x86,0x68,0xA7,0x78,
  0x40,0x08,0x61,0x18,0x02,0x28,0x23,0x38,
  0xCC,0xC9,0xED,0xD9,0x8E,0xE9,0xAF,0xF9,
  0x48,0x89,0x69,0x99,0x0A,0xA9,0x2B,0xB9,
  0xF5,0x5A,0xD4,0x4A,0xB7,0x7A,0x96,0x6A,
  0x71,0x1A,0x50,0x0A,0x33,0x3A,0x12,0x2A,
  0xFD,0xDB,0xDC,0xCB,0xBF,0xFB,0x9E,0xEB,
  0x79,0x9B,0x58,0x8B,0x3B,0xBB,0x1A,0xAB,
  0xA6,0x6C,0x87,0x7C,0xE4,0x4C,0xC5,0x5C,
  0x22,0x2C,0x03,0x3C,0x60,0x0C,0x41,0x1C,
  0xAE,0xED,0x8F,0xFD,0xEC,0xCD,0xCD,0xDD,
  0x2A,0xAD,0x0B,0xBD,0x68,0x8D,0x49,0x9D,
  0x97,0x7E,0xB6,0x6E,0xD5,0x5E,0xF4,0x4E,
  0x13,0x3E,0x32,0x2E,0x51,0x1E,0x70,0x0E,
  0x9F,0xFF,0xBE,0xEF,0xDD,0xDF,0xFC,0xCF,
  0x1B,0xBF,0x3A,0xAF,0x59,0x9F,0x78,0x8F,
  0x88,0x91,0xA9,0x81,0xCA,0xB1,0xEB,0xA1,
  0x0C,0xD1,0x2D,0xC1,0x4E,0xF1,0x6F,0xE1,
  0x80,0x10,0xA1,0x00,0xC2,0x30,0xE3,0x20,
  0x04,0x50,0x25,0x40,0x46,0x70,0x67,0x60,
  0xB9,0x83,0x98,0x93,0xFB,0xA3,0xDA,0xB3,
  0x3D,0xC3,0x1C,0xD3,0x7F,0xE3,0x5E,0xF3,
  0xB1,0x02,0x90,0x12,0xF3,0x22,0xD2,0x32,
  0x35,0x42,0x14,0x52,0x77,0x62,0x56,0x72,
  0xEA,0xB5,0xCB,0xA5,0xA8,0x95,0x89,0x85,
  0x6E,0xF5,0x4F,0xE5,0x2C,0xD5,0x0D,0xC5,
  0xE2,0x34,0xC3,0x24,0xA0,0x14,0x81,0x04,
  0x66,0x74,0x47,0x64,0x24,0x54,0x05,0x44,
  0xDB,0xA7,0xFA,0xB7,0x99,0x87,0xB8,0x97,
  0x5F,0xE7,0x7E,0xF7,0x1D,0xC7,0x3C,0xD7,
  0xD3,0x26,0xF2,0x36,0x91,0x06,0xB0,0x16,
  0x57,0x66,0x76,0x76,0x15,0x46,0x34,0x56,
  0x4C,0xD9,0x6D,0xC9,0x0E,0xF9,0x2F,0xE9,
  0xC8,0x99,0xE9,0x89,0x8A,0xB9,0xAB,0xA9,
  0x44,0x58,0x65,0x48,0x06,0x78,0x27,0x68,
  0xC0,0x18,0xE1,0x08,0x82,0x38,0xA3,0x28,
  0x7D,0xCB,0x5C,0xDB,0x3F,0xEB,0x1E,0xFB,
  0xF9,0x8B,0xD8,0x9B,0xBB,0xAB,0x9A,0xBB,
  0x75,0x4A,0x54,0x5A,0x37,0x6A,0x16,0x7A,
  0xF1,0x0A,0xD0,0x1A,0xB3,0x2A,0x92,0x3A,
  0x2E,0xFD,0x0F,0xED,0x6C,0xDD,0x4D,0xCD,
  0xAA,0xBD,0x8B,0xAD,0xE8,0x9D,0xC9,0x8D,
  0x26,0x7C,0x07,0x6C,0x64,0x5C,0x45,0x4C,
  0xA2,0x3C,0x83,0x2C,0xE0,0x1C,0xC1,0x0C,
  0x1F,0xEF,0x3E,0xFF,0x5D,0xCF,0x7C,0xDF,
  0x9B,0xAF,0xBA,0xBF,0xD9,0x8F,0xF8,0x9F,
  0x17,0x6E,0x36,0x7E,0x55,0x4E,0x74,0x5E,
  0x93,0x2E,0xB2,0x3E,0xD1,0x0E,0xF0,0x1E
};

/* 㷨Ȼûб䣬mystarһһһ:) */
int
StarPacket::FillParam(uint8_t *p)
{
  unsigned char code[0x17];
  int i;
  unsigned short ax,bx,dx;
  unsigned char icode[2];

  code[0] = 0;
  code[1] = 0;
  code[2] = 0x13;
  code[3] = 0x11;
  code[4] = 1;         //ط1ӦʵܻDHCP??
  *(uint32_t *)(code+5) = ip;
  *(uint32_t *)(code+9) = mask;
  *(uint32_t *)(code+13) = gate;
  *(uint32_t *)(code+17) = dns;
  
  ax = 0; bx = 0; dx = 0;
  for(i=0;i<21;i++){
    dx = ax;
    bx = 0;
    bx = (bx&0xff00) | code[i];
    dx &= 0xffff;
    dx >>= 8;
    dx ^= bx;
    bx = 0;
    bx &= 0x00ff;
    bx |= (ax&0xff)<<8;

    ax = Table[dx*2] | Table[dx*2+1]<<8;
    ax ^= bx;
  }
  
  code[0x15] = (unsigned char) ((ax & 0xff00) >> 8);
  code[0x16] = (unsigned char) (ax & 0x00ff);

  Crypt(code,0x17);
  memcpy(p,code,0x17);
}

int 
StarPacket::Crypt(unsigned char *p,int size)
{
  unsigned char a,b,c,d;
  int i;
  if (size<=0) return size;
  for(i=0;i<size;i++){
    b = d = c = a = p[i];
    c&=0x40;
    d>>=2;
    c|=d;
    d=a;
    c>>=2;
    d&=0x20;
    c|=d;
    d=a;
    c>>=2;
    d&=0x10;
    c|=d;

    d=a;
    d&=2;
    b<<=2;
    d|=b;
    b=a;
    d<<=2;
    b&=4;
    a&=8;
    d|=b;
    d<<=2;
    d|=a;

    c>>=1;
    d<<=1;
    c|=d;
  
    c=~c;
    p[i]=c;
  }
  return size;
}
